<?php
#   index.php - This is the main web front end to the web-based
#               configuration tools
#
#   Copyright (C) 2004 Frank Sorenson (frank AT tuxrocks DOT net)
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   as published by the Free Software Foundation; either version 2
#   of the License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

  include_once("UML_Common.php");

  function LoadConfig($Force = FALSE)
  {
    global $Config;

    static $ConfigRefreshTime = 0; /* last time we refreshed the configs */
    static $ConfigTableUpdateTime = 0; /* time the table was updated */

    if ($_SESSION['ConfigRefreshTime'] == 0) $Force = TRUE;

    if (($Force == FALSE) && ($_SESSION['ConfigRefreshTime'] + $Config['DBRefresh'] > $CurrentTime))
    {
      return(0);
    }

    $TableInfo = mysql_fetch_array(mysql_query("SHOW TABLE STATUS LIKE 'umls'"));

    $_SESSION['ConfigRefreshTime'] = time();
    if ($TableInfo['Update_time'] == $_SESSION['ConfigTableUpdateTime']) return(0); /* table has not been updated */

    $_SESSION['ConfigTableUpdateTime'] = $TableInfo['Update_time'];

    if (isset($Config['umls'])) unset($Config['umls']);
    $TempUMLData = GetTableData('umls', "SELECT * FROM `umls` ORDER BY `umid` ASC");
    $Config['umls'] = $TempUMLData;
    $Config['LocalUMLs'] = array_keys($Config['umls']);
    return(count($Config['umls']));
  }

  function WebInit()
  {
    global $Config, $DB_Config;

    session_start();
    $DB_Config['host'] = 'galileo';
    $DB_Config['user'] = 'uml_admin';
    $DB_Config['password'] = '';
    $DB_Config['name'] = 'UML';

    $Config['Action'] = GetVar('Action', 'status');
    $Config['RefreshDefault'] = 10;

    $Config['argv'] = $_SERVER['argv'];
    $Config['argc'] = $_SERVER['argc'];
    $Config['self'] = $_SERVER['PHP_SELF'];

    $TempVar = GetVar('Refresh', $_SESSION['Refresh']);
    if ($TempVar == '') $TempVar = 0;

    $_SESSION['Refresh'] = $TempVar;

    if (! isset($_SESSION['ConfigRefreshTime']))
      $_SESSION['ConfigRefreshTime'] = 0; /* last time we refreshed the configs */
    if (! isset($_SESSION['ConfigTableUpdateTime']))
      $_SESSION['ConfigTableUpdateTime'] = 0; /* time the table was updated */

    ConnectDB();
    LoadConfig(TRUE);
  }

  function OutputWebHeader($Menu = '')
  {
    include_once("html/header.html");
  }
  function OutputWebFooter()
  {
    include_once("html/footer.html");
  }

  function Menu_Add($Addition)
  {
    global $Config;

    if (isset($Config['Menu'])) $Config['Menu'] .= " | " . $Addition;
    else $Config['Menu'] = $Addition;
  }

  function GetVar($VarName, $Default = "")
  {
    global $HTTP_GET_VARS, $HTTP_POST_VARS;

    if (isset($HTTP_GET_VARS[$VarName])) return(stripslashes($HTTP_GET_VARS[$VarName]));
    if (isset($HTTP_POST_VARS[$VarName])) return(stripslashes($HTTP_POST_VARS[$VarName]));
    return($Default);
  }


  function CauseRefresh($Timeout=10) /* in seconds */
  {
?>
  <SCRIPT>
  function refreshPeriodic()
  {
    location.reload();
    timerID = setTimeout("refreshPeriodic()", <? echo ($Timeout * 1000 );?>);
  }
  timerID = setTimeout("refreshPeriodic()", <? echo ($Timeout * 1000 );?>);
  </SCRIPT>
<?
  } /* end of CauseRefresh */

  function CauseRedirect($Destination, $Timeout = 0)
  {
?>
  <SCRIPT>
  function RedirectNow()
  {
    window.location.href = "<? echo $Destination; ?>";
  }
  function Redirect()
  {
    setTimeout("RedirectNow()", <? echo $Timeout; ?>);
  }
  Redirect();
  </SCRIPT>
<?
  }

  function UMLStatus($UML_ID)
  {
    global $Config;
    return($Config['umls'][$UML_ID]['status']['status']);
  }

  function ChangePassword($User = '')
  {
    global $Config;

    $User = GetVar('passuser', $User);
    if ($User == '') $User = $_SESSION['UserName'];
    $TempPass1 = GetVar('newpass1', '');
    $TempPass2 = GetVar('newpass2', '');

    if (($TempPass1 != $TempPass2) || ($TempPass1 == '') || ($TempPass2 == ''))
    {
      if ($TempPass1 != $TempPass2) echo "<center>Passwords do not match</center><br>\n";
      echo "<center>Please choose the user and enter the new password\n";
      echo "<form action='?' method='POST'>\n";
      echo " <input type='hidden' name='Action' value='password'>\n";
      echo " <table border='0' cellspacing='1' cellpadding='0'>\n";
      echo "  <tr><td align=right>Change password for</td><td align=left><select name='passuser'>\n";
      if (! isset($Config['umls'][$User])) /* web user only--not UML */
      {
        echo "<option value='WEBUSER'>Web user " . $_SESSION['UserName'] . "</option>\n";
      }
      $RunningUMLs = array();
      $DeployingUMLs = array();
      $UnconfiguredUMLs = array();
      foreach ($Config['ManageableUMLs'] as $CurrentUML_ID)
      {
        $CurrentUML = $Config['umls'][$CurrentUML_ID];
        $CurrentUMLStatus = UMLStatus($CurrentUML_ID);
        if ($CurrentUMLStatus == 'off') echo "<option value='$CurrentUML_ID'>$CurrentUML_ID (web and UML root)</option>\n";
        else if ($CurrentUMLStatus == 'on')
        {
          echo "<option value='$CurrentUML_ID'>$CurrentUML_ID (web only *)</option>\n";
          $RunningUMLs[] = $CurrentUML_ID;
        }
        else if ($CurrentUMLStatus == 'deploying')
        {
          echo "<option value='$CurrentUML_ID'>$CurrentUML_ID (web only *)</option>\n";
          $DeployingUMLs[] = $CurrentUML_ID;
        }
        else
        {
          echo "<option value='$CurrentUML_ID'>$CurrentUML_ID (web only *)</option>\n";
          $UnconfiguredUMLs[] = $CurrentUML_ID;
        }
      }
      echo "</select><br>";
      echo "</td></tr>\n";
      echo "  <tr>\n";
      echo "   <td align='right'>Password:</td>\n";
      echo "   <td align=left><input type='password' name='newpass1'></td>\n";
      echo "  </tr>\n";
      echo "  <tr>\n";
      echo "   <td align='right'>Password (again):</td>\n";
      echo "   <td align=left><input type='password' name='newpass2'></td>\n";
      echo "  </tr>\n";

      echo "  <tr>\n";
      echo "  <td colspan=2 align=center><input type='submit' name='submit' value='Change password' border='0'></td>\n";
      echo " </tr>\n";
      echo "</table>\n";
      echo "</form>\n";

      if (count($RunningUMLs) || count($UnconfiguredUMLs) || count($DeployingUMLs))
      {
        echo "<small><b>*</b> UML root passwords cannot be changed on running, deploying, or unconfigured UMLs</small><br>\n";
      }
      echo "</center>\n";
    }
    else
    {
      if ($User == 'WEBUSER')
      {
        echo "Setting new user password for " . $_SESSION['UserName'] . "<br>\n";
        SetUserPassword($_SESSION['UserName'], $TempPass1);
        $_SESSION['Password'] = $TempPass1;
      }
      else
      {
        $UML_ID = $User;
        $CurrentUMLStatus = UMLStatus($UML_ID);
        SetUserPassword($UML_ID, $TempPass1);
        if ($CurrentUMLStatus == 'off')
        {
          $Result = mysql_query("INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`, `arg1`, `arg2`) VALUES ('$UML_ID', '" . PrettyPrintHost($UML_ID) . "', 'password', '" . CurrentDate() . "', 'root', '" . md5crypt($TempPass1) . "');") or die("Could not add 'password' to queue" . mysql_error());
          echo "Setting both web and UML root passwords<br>\n";
        }
        else
        {
          echo "Setting only web password (UML is " . PrettyPrintStatus($UML_ID) . ")<br>\n";
        }
        if ($User == $_SESSION['UserName']) $_SESSION['Password'] = $TempPass1;
      }
sleep(3);
      CauseRedirect("?Action=status", 0);
    }
  }

  function GetDistros()
  {
    global $Config;

    if (isset($Config['Distros'])) return($Config['Distros']);
    $AvailableDistros = GetTableData('Distros', "SELECT * FROM `Distros` WHERE `Avail`='TRUE' ORDER BY `Text` ASC");
    $Config['Distros'] = $AvailableDistros;
    return($AvailableDistros);
  }

  function ConfigureUML($UML_ID)
  {
    global $Config;

    $ConfigureStatus = UMLStatus($UML_ID);
    $Host = PrettyPrintHost($UML_ID);

    $AvailableDistros = GetDistros();
    $ChangesMade = "";
    $Deploying = FALSE;
    $TempOwners = GetVar('owners', $Config['users'][$UML_ID]['Names']);
    $TempPass1 = GetVar('newpass1', '');
    $TempPass2 = GetVar('newpass2', '');
    $CurrentRunlevel = $Config['umls'][$UML_ID]['config']['Runlevel'];
    $TempRunlevel = GetVar('Runlevel', $CurrentRunlevel);
    $TempDistro = GetVar('Distro');

    $TotalMemory = $Config['umls'][$UML_ID]['config']['TotalMemory'];
    $CurrentMemory = $Config['umls'][$UML_ID]['config']['mem'];
    $TempMem = GetVar('Memory', $CurrentMemory);
    if ($TempMem > $TotalMemory) $TempMem = $TotalMemory;
    if ($TempMem <= 0) $TempMem = $TotalMemory;
    $TempBoot = GetVar('boot');

    echo "<center>\n";
    echo " <form action='?' method=POST>\n";
    echo "  <input type=hidden name=Action value=configure>\n";
    echo "  <input type=hidden name=uml value=$UML_ID>\n";

    echo " <table border=1>\n";
    echo "  <tr><td colspan=2 align=center><font size='+1'>";
    if ($ConfigureStatus == 'deploying') echo "Deploying/";
    echo "Configuring $UML_ID on $Host</font></td></tr>\n";

    if ($TempOwners != $Config['users'][$UML_ID]['Names'])
    {
      $Result = mysql_query("UPDATE `users` SET `Names`='" . mysql_escape_string($TempOwners) . "' WHERE `username`='$UML_ID';") or die("Could not update owners" . mysql_error());
      $ChangesMade .= "Updated owners<br>\n";
    }
    echo "  <tr><td>UML Owners</td><td><textarea name=owners rows=4 cols=30>$TempOwners</textarea></td></tr>\n";

    echo "  <tr><td>Status</td><td><b><font size='+1'>" . PrettyPrintStatus($UML_ID) . "</font></b></td></tr>\n";
    if ($ConfigureStatus == 'unconfig')
    {
      if ((($TempDistro != '') && (! isset($AvailableDistros[$TempDistro]))) || ($TempDistro == '')) 
      {
        echo "  <tr><td align=right>Distribution:</td><td><select name='Distro'>\n";
        foreach ($AvailableDistros as $Key => $Value)
        {
          echo "   <option value='" . $Value['ID'] . "'";
          if ($Value['Default'] == 'TRUE') echo " selected";
          echo ">" . $Value['Text'] . "</option>\n";
        }
        echo "   </select>\n";
        echo "  </tr>\n";
      }
      else /* trying to deploy distro */
      {
        if (($TempPass1 != '') && ($TempPass2 != '') && ($TempPass1 == $TempPass2) && ($TempDistro != '') && (isset($AvailableDistros[$TempDistro])))
        {
          $Query = "INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`, `arg1`) VALUES ('$UML_ID', '$Host', 'deploy', '" . CurrentDate() . "', '$TempDistro');";
          $Result = mysql_query($Query) or die("Could not add 'deploy' to queue: " . mysql_error());
          $Result = mysql_query("UPDATE `umls` SET `Distro`='$TempDistro' WHERE `umid`='$UML_ID';") or die("Could not update distribution: " . mysql_error());
          $ChangesMade .= "Deploying $TempDistro to $UML_ID<br>\n";
          $Deploying = TRUE;
        }
        else
        {
          if (($TempPass1 == '') || ($TempPass2 == '') || ($TempPass1 != $TempPass2)) $ChangesMade .= "Password field(s) empty or do not match<br>\n";
          if (($TempDistro == '') || (! isset($AvailableDistros[$TempDistro]))) $ChangesMade .= "Distribution not set or not available<br>\n";
        }
      }
    }

    if (($TempPass1 != '') && ($TempPass2 != '') && ($TempPass1 == $TempPass2))
    {
      /* try setting password */
      $Query = "INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`, `arg1`, `arg2`) VALUES ('$UML_ID', '$Host', 'password', '" . CurrentDate() . "', 'root', '" . md5crypt($TempPass1) . "');";
      $Result = mysql_query($Query) or die("Could not add 'password' to queue" . mysql_error());
      SetUserPassword($UML_ID, $TempPass1);
      $ChangesMade .= "Set password for $UML_ID (web and UML root)<br>\n";
    }
    if (($ConfigureStatus == 'unconfig') || ($ConfigureStatus == 'off'))
    {
      echo "  <tr><td align=right>root password:</td><td><input type=password name=newpass1></td></tr>\n";
      echo "  <tr><td align=right>confirm password:</td><td><input type=password name=newpass2></td></tr>\n";
    }

    if ($CurrentMemory != $TempMem)
    {
      $Query = "UPDATE `umls` SET `mem` = '$TempMem' WHERE `umid` = '$UML_ID';";
      $Result = mysql_query($Query) or die("Could not set memory size: " . mysql_error());
      $ChangesMade .= "Changed UML memory size<br>\n";
    }
    echo "  <tr><td align=right>Memory ($TotalMemory available):</td><td><input name=Memory value='" . $TempMem . "'></td></tr>\n";

    if ($TempRunlevel != $CurrentRunlevel)
    {
      $Result = mysql_query("UPDATE `umls` SET `Runlevel` = '$TempRunlevel' WHERE `umid` = '$UML_ID';") or die("Could not update runlevel: " . mysql_error());
      $ChangesMade .= "Changed runlevel<br>\n";
    }
    echo "  <tr><td colspan=2 align=center>Boot runlevel: <input type=radio name=Runlevel value=default id=default_runlevel";
    if ($TempRunlevel != 'single') echo " checked";
    echo "><label for=default_runlevel>default</label> <input type=radio name=Runlevel value=single id=single_runlevel";
    if ($TempRunlevel == 'single') echo " checked";
    echo "><label for=single_runlevel>single-user</label></td></tr>\n";

    if ($ConfigureStatus == 'unconfig')
    {
      echo "  <tr><td colspan=2 align='right'><label for='boot_box'>Boot after configuring</label><input type='checkbox' name='boot' id='boot_box' checked></td></tr>\n";
    }
    if (($TempBoot == 'on') && ($Deploying == TRUE))
    {
      $Query = "INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`) VALUES ('" . $UML_ID . "', '$Host', 'boot', '" . CurrentDate() . "');";
      $Result = mysql_query($Query) or die("Could not add 'boot' to queue " . mysql_error());
      $Result = mysql_query("UPDATE `umls` SET `onoff` = 'on' WHERE `umid` = '$UML_ID';") or die("Could not set onoff boot status " . mysql_error());
      $ChangesMade .= "Booted UML<br>\n";
    }

    echo "  <tr><td colspan=2 align=center><input type=submit value=Submit></td></tr>\n";
    echo "  </form>\n";
    echo " </table>\n";
    echo "</center>\n";
    echo $ChangesMade;
    if ($ChangesMade != '') CauseRedirect("?Action=status", 200);
  }

  function Redirect($NewURL)
  {
    header("Location: $NewURL"); /* Redirect Browser */
    exit;
  }

  function md5crypt($Plaintext, $Salt = '')
  {
    if ($Salt == '')
    {
      $Salt = '$1$';
      for ($Counter = 0 ; $Counter < 9 ; $Counter ++)
      {
        $Salt .= substr(crypt(rand(1,65536)), 3, 1);
      }
    }
    $Salt = substr($Salt, 0, 12);
    return(crypt($Plaintext, $Salt));
  }

  function SetUserPassword($User, $Password)
  {
    global $Config;

    $PassHash = md5crypt($Password);
    $Query = "UPDATE `users` SET `password` = '" . mysql_escape_string($PassHash) . "' WHERE `username` = '$User' LIMIT 1;";
    mysql_query($Query) or die("Could not update password\n");
  }

  function DisplayLoginScreen($Message = '')
  {
    OutputWebHeader('');
    echo $Message;
?>
  <center>Please login:<br>
  <form name="LoginForm" action="?" method=POST>
    <input type=hidden name="Action" value="login">
    <table border="0" cellspacing="1" cellpadding="0">
      <tr>
        <td align="right">Username:</td>
        <td><input type="Text" name="username" size="16" maxlength="16"></td>
      </tr>
      <tr>
        <td align=right>Password:</td>
        <td><input type="password" name="password" size=16 maxlength=16></td>
      </tr>
      <tr>
        <td></td>
        <td><input type="submit" name="submit" value="Login" border="0"></td>
      </tr>
    </table>
  </form>
  </center>
<?
    OutputWebFooter();
  }

  function Auth()
  {
    global $Config;

    $UserName = &$_SESSION['UserName'];

    if (isset($_SESSION['UserName'])) $_SESSION['UserName'] = GetVar('username', $_SESSION['UserName']);
    else $_SESSION['UserName'] = GetVar('username');
    if (isset($_SESSION['Password'])) $_SESSION['Password'] = GetVar('password', $_SESSION['Password']);
    else $_SESSION['Password'] = GetVar('password');

    if ($Config['Action'] == 'logout')
    {
      $_SESSION['UserName'] = '';
      $_SESSION['Password'] = '';
    }

    if (($_SESSION['UserName'] == '') || ($_SESSION['Password'] == ''))
    {
      DisplayLoginScreen();
      exit;
    }

    $UserInfo = GetTableData('users', "SELECT * FROM `users` ORDER BY `username` ASC");

    $RawInfo = $UserInfo[$_SESSION['UserName']];
    if (! isset($RawInfo))
    {
      DisplayLoginScreen("Login failed<br>\n");
      exit;
    }

    $PassHash = md5crypt($_SESSION['Password'], $RawInfo[password]);

    if ($RawInfo[password] == $PassHash)
    {
      $Config['users'] = $UserInfo;
      return(1);
    }
    DisplayLoginScreen();
    exit;
  }

  function GetStatus_All()
  {
    global $Config;

    $NumUMLs = count($Config['ManageableUMLs']);

    if ($NumUMLs == 0) return(0);
    $TempStatus = GetTableData('Status', "SELECT * FROM `Status` ORDER BY `ID` ASC");

    foreach ($Config['ManageableUMLs'] as $UML_ID)
    {
      $Config['umls'][$UML_ID]['status'] = $TempStatus[$UML_ID];
    }
  }

  function GetManageableUMLs()
  {
    global $Config;

    $ValidUMLs = array();
    $Query = "SELECT * FROM umls ORDER BY `umid` ASC";
    $AllUMLs = GetTableData('umls', $Query);
    $NumUMLs = count($AllUMLs);

    if (count($AllUMLs) == 0) return(array());

    $UserInfo = GetTableData('users', "SELECT * FROM `users` WHERE `username`='" . $_SESSION['UserName'] . "' LIMIT 1;");
    $Config['UserInfo'] = $UserInfo[$_SESSION['UserName']];

    $MyUID = $Config['UserInfo']['uid'];
    $MyGIDs = GetTableData('Group_Membership', "SELECT `GID`,`Type` from `Group_Membership` WHERE `UID`='$MyUID' ORDER BY `GID` ASC");
    $AllGroups = GetTableData('Groups');

    foreach ($MyGIDs as $Key => $CurrentGID)
    {
      $MyGIDs[$Key]['GroupName'] = $AllGroups[$Key]['Name'];
      $MyGIDs[$Key]['GroupDescription'] = $AllGroups[$Key]['Description'];
    }
    $MyGIDArray = array_keys($MyGIDs);

    foreach ($AllUMLs as $CurrentUML)
    {
      if (($_SESSION['UserName'] == $CurrentUML['umid']) || (in_array($CurrentUML['GID'], $MyGIDArray)) || ($Config['users'][$_SESSION['UserName']]['admin'] == 'TRUE'))
      {
        $ValidUMLs[] = $CurrentUML['umid'];
        $Config['umls'][$CurrentUML['umid']]['config'] = $CurrentUML;
      }
    }
    natsort($ValidUMLs);
    $Config['ManageableUMLs'] = $ValidUMLs;
    return($ValidUMLs);
  }

  function PrettyPrintStatus($UML_ID, $Endl = '')
  {
    global $Config;

    $Status = $Config['umls'][$UML_ID]['status']['status'];
    if ($Status == 'on') return('Running' . $Endl);
    if ($Status == 'off') return('Off' . $Endl);
    if ($Status == 'unconfig') return('Unconfigured' . $Endl);
    if ($Status == 'deploying') return('Deployment in process' . $Endl);
    return('Unknown' . $Endl);
  }

  function PrettyPrintMemory($UML_ID, $Endl = '')
  {
    global $Config;

    $CurrentUML = $Config['umls'][$UML_ID];
    $UML_Status = $CurrentUML['status'];
    $UML_Config = $CurrentUML['config'];
    if ($Config['umls'][$UML_ID]['status']['status'] == 'unconfig') return($Config['umls'][$UML_ID]['config']['TotalMemory'] . "MB available" . $Endl);
    return($Config['umls'][$UML_ID]['config']['mem'] . "MB (" . $Config['umls'][$UML_ID]['config']['TotalMemory'] . "MB available)" . $Endl);
  }

  function PrettyPrintKernel($UML_ID, $Endl = '')
  {
    global $Config;
    if ($Config['umls'][$UML_ID]['status']['status'] != 'on') return('');
    return($Config['umls'][$UML_ID]['status']['kernel'] . $Endl);
  }
  function PrettyPrintUptime($UML_ID, $Endl = '')
  {
    global $Config;
    if ($Config['umls'][$UML_ID]['status']['status'] != 'on') return('');
    return(' up ' . $Config['umls'][$UML_ID]['status']['uptime'] . $Endl);
  }
  function PrettyPrintRunlevel($UML_ID, $Endl = '')
  {
    global $Config;
    if ($Config['umls'][$UML_ID]['status']['status'] != 'on') return('');
    return('(' . $Config['umls'][$UML_ID]['status']['runlevel'] . ')' . $Endl);
  }
  function PrettyPrintLoadaverage($UML_ID, $Endl = '')
  {
    global $Config;
    if ($Config['umls'][$UML_ID]['status']['status'] != 'on') return('');
    return('load: ' . $Config['umls'][$UML_ID]['status']['load'] . $Endl);
  }
  function PrettyPrintDistro($UML_ID, $Endl = '')
  {
    global $Config;

    $AvailableDistros = GetDistros();
    if (isset($Config['umls'][$UML_ID]['Distro'])) $Distro = $Config['umls'][$UML_ID]['Distro'];
    else $Distro = '';

    if ($Distro != '')
    {
      return($Config['Distros'][$Distro]['Description'] . " system" . $Endl);
    }
    return('');
  }
  function PrettyPrintShutdown($UML_ID, $Endl = '')
  {
    global $Config;

    if ($Config['umls'][$UML_ID]['status']['status'] == 'on') return("<a href='?Action=shutdown&amp;uml=$UML_ID' onClick=\"return confirm('Shutdown $UML_ID?')\">Shutdown</a>" . $Endl);
    return('');
  }
  function PrettyPrintBoot($UML_ID, $Endl = '')
  {
    global $Config;

    if ($Config['umls'][$UML_ID]['status']['status'] == 'off') return("<a href='?Action=boot&amp;uml=$UML_ID'>Boot</a>" . $Endl);
    return('');
  }
  function PrettyPrintReboot($UML_ID, $Endl = '')
  {
    global $Config;

    if ($Config['umls'][$UML_ID]['status']['status'] == 'on') return("<a href='?Action=reboot&amp;uml=$UML_ID' onClick=\"return confirm('Reboot $UML_ID?')\">Reboot</a>" . $Endl);
    return('');
  }
  function PrettyPrintConfigureUML($UML_ID, $Endl = '')
  {
    global $Config;

    if (($Config['umls'][$UML_ID]['status']['status'] == 'unconfig') || ($Config['umls'][$UML_ID]['status']['status'] == 'off')) return("<a href='?Action=configure&amp;uml=$UML_ID'>Configure UML</a>" . $Endl);
    return('');
  }
  function PrettyPrintOtherActions($UML_ID, $Endl = '')
  {
    global $Config;

    $Status = $Config['umls'][$UML_ID]['status']['status'];
    if (!isset($Config['umls'][$UML_ID]['status']['status'])) return("Nothing to do" . $Endl);
    if (($Config['umls'][$UML_ID]['status']['status'] == 'Unknown') || ($Config['umls'][$UML_ID]['status']['status'] == 'deploying')) return("Nothing to do" . $Endl);
    return('');
  }
  function PrettyPrintHost($UML_ID, $Endl = '')
  {
    global $Config;
    return($Config['umls'][$UML_ID]['config']['host'] . $Endl);
  }
  function PrettyPrintConnecting($UML_ID, $Endl = '')
  {
    global $Config;

    if ($Config['umls'][$UML_ID]['status']['status'] == 'on')
    {
      $ReturnValue = "Connect to console: <tt>ssh -l $UML_ID " . PrettyPrintHost($UML_ID) . "</tt>" . $Endl;
      $ReturnValue .= "Connect to UML machine: <tt>ssh $UML_ID</tt>" . $Endl;
      return($ReturnValue);
    }
    return('');
  }
  function PrettyPrintStatusTime($UML_ID, $Endl = '')
  {
    global $Config;
    if (isset($Config['umls'][$UML_ID]['status']['UpdateTime']) && ($Config['umls'][$UML_ID]['status']['UpdateTime'] != '')) return("(as of " . $Config['umls'][$UML_ID]['status']['UpdateTime'] . ")" . $Endl);
    return('');
  }
  function PrettyPrintRefresh($Link = "?Action=status")
  {
    return("<a href='$Link'>refresh now</a>");
  }
  function PrettyPrintOwners($UML_ID, $Endl = '')
  {
    global $Config;

    $Owners = str_replace("\n", "<br>", $Config['users'][$UML_ID]['Names']);
    return($Owners . $Endl);
  }

  function DisplayUMLStatus($UML_ID)
  {
    global $Config;

    echo "  <tr>\n";
    echo "    <td><b><font size='+1'><a href='?Action=status&amp;uml=$UML_ID'>$UML_ID</a></font></b><br>";
    echo PrettyPrintOwners($UML_ID, "<br>");

    echo "</td>\n";

    echo "    <td><b><font size='+1'>" . PrettyPrintStatus($UML_ID) . '</font></b> ' . PrettyPrintRunlevel($UML_ID) . "<br><small>" . PrettyPrintStatusTime($UML_ID) . "</small><br>";
    echo PrettyPrintBoot($UML_ID, "<br>");
    echo PrettyPrintReboot($UML_ID, "<br>");
    echo PrettyPrintShutdown($UML_ID, "<br>");
    echo PrettyPrintConnecting($UML_ID, "<br>");
    echo PrettyPrintConfigureUML($UML_ID, "<br>");
    echo PrettyPrintOtherActions($UML_ID, "<br>");
    echo "</td>\n";

    echo "    <td>";
    echo "Host: " . PrettyPrintHost($UML_ID, "<br>");
    echo PrettyPrintMemory($UML_ID, "<br>");
    echo PrettyPrintKernel($UML_ID, "<br>");
    echo PrettyPrintUptime($UML_ID, "<br>");
    echo PrettyPrintLoadaverage($UML_ID, "<br>");
    echo "</td>\n";

    echo "  </tr>\n";
  }

  function DisplayUMLStatus_Single($UML_ID)
  {
    global $Config;

    echo "<center>\n";
    echo "<table border=1>\n";
    echo " <tr><td align=center colspan=2><b><font size='+1'>$UML_ID</font></b><br>";
    echo PrettyPrintOwners($UML_ID, "<br>");

    echo "</td></tr>\n";

    echo " <tr><td><b><font size='+1'>Host</font></b></td><td>" . PrettyPrintHost($UML_ID) . "</td></tr>\n";
    echo " <tr><td><b><font size='+1'>UML Status</font></b></td><td><b><font size='+1'>" . PrettyPrintStatus($UML_ID) . '</font></b> ' . PrettyPrintRunlevel($UML_ID) . "<br><small>" . PrettyPrintStatusTime($UML_ID) . "</small></td></tr>\n";
    echo " <tr><td><b><font size='+1'>Info</font></b></td><td>" . PrettyPrintMemory($UML_ID, "<br>") . PrettyPrintKernel($UML_ID, "<br>") . PrettyPrintUptime($UML_ID, "<br>") . PrettyPrintLoadaverage($UML_ID, "<br>") . "</td></tr>\n";
    echo "  <tr><td><b><font size='+1'>Control</font></b></td><td>" . PrettyPrintBoot($UML_ID, "<br>") . PrettyPrintReboot($UML_ID, "<br>") . PrettyPrintShutdown($UML_ID, "<br>") . PrettyPrintConnecting($UML_ID, "<br>") . PrettyPrintConfigureUML($UML_ID, "<br>") . PrettyPrintOtherActions($UML_ID, "<br>")  . "</td></tr>\n";
    echo " <tr><td align=center colspan=2>" . PrettyPrintRefresh("?Action=status&amp;uml=$UML_ID") . "</td></tr>\n";
    echo "</table></center>\n";
    return;
  }

  function DisplayUMLStatus_All()
  {
    global $Config;

    echo "<center>\n";
    echo "<table border=1>\n";
    echo "  <tr>\n";
    echo "    <td align=center><b><font size='+1'>UML</font></b></td>\n";
    echo "    <td align=center><b><font size='+1'>UML Status</font></b></td>\n";
    echo "    <td align=center><b><font size='+1'>Info</font></b></td>\n";
    echo "  </tr>";
    foreach ($Config['ManageableUMLs'] as $CurrentHost)
    {
      DisplayUMLStatus($CurrentHost);
    }
    echo "  <tr>\n";
    echo "    <td align=center colspan=3>" . PrettyPrintRefresh("?Action=status") . "</td>\n";
    echo "  </tr>\n";
    echo "</table>\n";
    echo "</center>\n";
  }

  function CheckPermission($UML_ID, $Die = 0) /* die if permission denied */
  {
    global $Config;

    if (in_array($UML_ID, $Config['ManageableUMLs'])) return(1);
    return(0);
  }

  function WebMain()
  {
    global $Config;

    Auth(); /* Auth will only return if successful */
    GetManageableUMLs();
    GetStatus_All();

    $UML_ID = GetVar('uml');

    Menu_Add('<a href="?Action=logout">logout</a>');
    Menu_Add('<a href="?Action=password">passwords</a>');
    if ((($Config['Action'] == 'status') && ($UML_ID != '')) || ($Config['Action'] != 'status'))
    {
      Menu_Add('<a href="?Action=status">status overview</a>');
    }

    if ($Config['Action'] == 'status')
    {
      if ($_SESSION['Refresh'] != 0)
      {
          $NewEntry = '<a href="?Action=status&amp;Refresh=0';
          if ($UML_ID != '') $NewEntry .= '&amp;uml=' . $UML_ID;
          $NewEntry .= '">stop refresh (' . $_SESSION['Refresh'] . ' sec.)</a>';
          Menu_Add($NewEntry);
      }
      else
      {
        $NewEntry = '<a href="?Action=status&amp;Refresh=' . $Config['RefreshDefault'];
        if (($UML_ID != '') && ($Config['Action'] == 'status')) $NewEntry .= '&amp;uml=' . $UML_ID;
        $NewEntry .= '">start refresh (' . $Config['RefreshDefault'] . ' sec.)</a>';
        Menu_Add($NewEntry);
      }
      $RefreshNowLink = "?Action=status";
      if ($UML_ID != '') $RefreshNowLink .= "&amp;uml=$UML_ID";
      Menu_Add(PrettyPrintRefresh($RefreshNowLink));
    }

    OutputWebHeader($Config['Menu']);

    if ($Config['Action'] == 'login')
    {
      echo "<center><h1>Logging in as " . $_SESSION['UserName'] . "...\n";
      CauseRedirect("?Action=status", 1);
      echo "</h1></center>\n";
      return;
    }
    if ($Config['Action'] == 'password')
    {
      /* display table of users we can manage, and allow password changes */
    }


    echo "<center><h1>User: " . $_SESSION['UserName'] . "</h1></center>\n";
    if ($Config['Action'] == 'boot')
    {
      if (UMLStatus($UML_ID) == 'off')
      {
        if (! CheckPermission($UML_ID))
        {
          echo "User " . $Config['UserName'] . " can not manage $UML_ID<br>\n";
          sleep(10);
        }
        else
        {
          $Query = "INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`) VALUES ('" . $UML_ID . "', '" . PrettyPrintHost($UML_ID) . "', 'boot', '" . CurrentDate() . "');";
          $Result = mysql_query($Query) or die("Could not add 'boot' to queue " . mysql_error());
          $Result = mysql_query("UPDATE `umls` SET `onoff` = 'on' WHERE `umid` = '$UML_ID';") or die("Could not set onoff boot status " . mysql_error());
        }
        CauseRedirect("?Action=status", 0);
        exit(0);
      }
      else echo "UML $UML_ID already booted\n";
      DisplayUMLStatus_All();
    }
    else if ($Config['Action'] == 'shutdown')
    {
      if (UMLStatus($UML_ID) == 'on')
      {
        if (! CheckPermission($UML_ID))
        {
          echo "User " . $Config['UserName'] . " can not manage $UML_ID<br>\n";
          sleep(10);
        }
        else
        {
          $Query = "INSERT INTO `queue` (`umid`, `host`, `action`, `entrytime`) VALUES ('" . $UML_ID . "', '" . PrettyPrintHost($UML_ID) . "', 'shutdown', '" . CurrentDate() . "');";
          $Result = mysql_query($Query) or die("Could not add 'shutdown' to queue " . mysql_error());
          $Result = mysql_query("UPDATE `umls` SET `onoff` = 'off' WHERE `umid` = '$UML_ID';") or die("Could not set onoff boot status " . mysql_error());
        }
        CauseRedirect("?Action=status", 0);
        exit(0);
      }
      else echo "UML $UML_ID is already halted or not configured\n";
      DisplayUMLStatus_All();
    }
    else if ($Config['Action'] == 'status')
    {
      if (count($Config['ManageableUMLs']) == 1) $UML_ID = $Config['ManageableUMLs'][0];
      if ($UML_ID == '')
      {
        DisplayUMLStatus_All();
      }
      else
      {
        DisplayUMLStatus_Single($UML_ID);
      }
      if ($_SESSION['Refresh'] != 0) CauseRefresh($_SESSION['Refresh']);
    }
    else if ($Config['Action'] == 'password')
    {
      ChangePassword();
      exit(0);
    }
    else if ($Config['Action'] == 'configure')
    {
      ConfigureUML($UML_ID);
    }
  }


  WebInit();

  WebMain();
#echo "<pre>";
#print_r($Config);
#echo "</pre>";
  OutputWebFooter();

?>
